/*
 * $Id: Dots.as,v 1.1.1.1 2006/07/17 03:27:32 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.dngn {
  import flash.display.BitmapData;
  import flash.geom.Rectangle;
  import Dngn;

  /**
   * Dots image in background.
   */
  public class Dots {
    private static var dotSize:int = 6;
    private static var colors:Array;
    private static var mountHeight:int = 30;
    private var dWidth:int, dHeight:int;
    private var rect:Rectangle;
    private var by:Array;
    private var bgy:Number, bgyVel:Number, bgyVelCnt:int;

    public function Dots() {
      colors = new Array;
      dWidth = Dngn.screenWidth / dotSize;
      dHeight = Dngn.screenHeight / dotSize;
      for (var y:int = 0; y < dHeight; y++) {
        var lc:Array = new Array;
        for (var x:int = 0; x < dWidth; x++) {
          var cl:uint = 0;
          lc.push(cl);
        }
        colors.push(lc);
      }
      rect = new Rectangle(0, 0, dotSize - 1, dotSize - 1);
      by = new Array;
      for (x = 0; x < dWidth; x++)
	by.push(0);
      bgy = mountHeight / 3;
      bgyVelCnt = 0;
      for (x = 0; x < dWidth; x++)
	scrollBackground();
    }

    private function scrollBackground():void {
      bgyVelCnt--;
      if (bgyVelCnt <= 0) {
	var ty:Number = Math.random() * (mountHeight * 2 / 3);
	bgyVelCnt = 10 + Math.random() * 10;
	bgyVel = (ty - bgy) / bgyVelCnt;
      }
      bgy += bgyVel;
      for (var x:int = 0; x < dWidth - 1; x++)
	by[x] = by[x + 1];
      by[dWidth - 1] = bgy;
    }

    public function pset(x:int, y:int, color:uint):void {
      var dx:int = x / dotSize;
      var dy:int = y / dotSize;
      if (dx >= 0 && dx < dWidth && dy >= 0 && dy < dHeight)
        colors[dx][dy] = color;
    }

    public function setBackground():void {
      for (var x:int = 0; x < dWidth; x++) {
	for (var oy:int = by[x]; oy < mountHeight; oy++) {
	  var a:uint = 150 - oy * (150 / mountHeight);
	  colors[x][dHeight - 1 - oy] = (a << 16) | (a << 8) | a;
	}
      }
      scrollBackground();
    }

    public function update(buffer:BitmapData):void {
      for (var y:int = 0; y < dHeight; y++) {
        for (var x:int = 0; x < dWidth; x++) {
          var c:uint = colors[x][y];
          if (c > 0) {
            var r:uint = (((c & 0xff0000) >> 16) * 0.95) << 16;
            var g:uint = (((c & 0xff00) >> 8) * 0.95) << 8;
            var b:uint = (((c & 0xff) >> 0) * 0.95) << 0;
            c = r | g | b;
            colors[x][y] = c;
            rect.x = x * dotSize;
            rect.y = y * dotSize;
            buffer.fillRect(rect, c);
          }
        }
      }
    }
  }
}
