/*
 * $Id: TurretButton.as,v 1.1.1.1 2006/07/17 03:27:32 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.dngn {
  import flash.display.SimpleButton;
  import flash.display.Sprite;
  import flash.display.Bitmap;
  import flash.display.BitmapData;
  import flash.events.MouseEvent;
  import flash.geom.Rectangle;

  /**
   * Button to change a turret moving pattern.
   */
  public class TurretButton extends SimpleButton {
    public static var buttonWidth:int = 48;
    public static var buttonHeight:int = 48;
    private var turretSpec:TurretSpec;
    private var turretGroup:TurretGroup;

    public function TurretButton(turretSpec:TurretSpec, turretGroup:TurretGroup) {
      this.turretSpec = turretSpec;
      this.turretGroup = turretGroup;
      downState = createTurretSprite(0);
      overState = createTurretSprite(2);
      upState = hitTestState = createTurretSprite(1);
      useHandCursor = true;
      addEventListener(MouseEvent.CLICK, onClick);
    }

    public function onClick(evt:MouseEvent):void {
      turretGroup.setSpec(turretSpec);
    }

    private function createTurretSprite(lvl:int):Sprite {
      var sp:Sprite = new Sprite;
      var buffer:BitmapData = new BitmapData(buttonWidth, buttonHeight, false, 0);
      var dummyBuffer:BitmapData = new BitmapData(buttonWidth, buttonHeight, false, 0);
      var screen:Bitmap = new Bitmap(buffer);
      sp.addChild(screen);
      buffer.fillRect(buffer.rect, 0);
      var dw:int = buttonWidth / 6;
      var dh:int = buttonHeight / 6;
      for (var x:int = 0; x < dw; x++) {
        for (var y:int = 0; y < dh; y++) {
          if (!(x == 0 || x == dw - 1 || y ==0 || y == dh - 1)) {
            switch (lvl) {
            case 0:
              buffer.fillRect(new Rectangle(x * 6 + 2, y * 6 + 2, 2, 2), 0x114411);
              break;
            case 1:
            case 2:
              buffer.fillRect(new Rectangle(x * 6 + 1, y * 6 + 1, 3, 3), 0x226622);
              break;
            }
          }
        }
      }
      var tg:TurretGroup = new TurretGroup(null);
      tg.setSpec(turretSpec);
      TurretGroup.centerX = buttonWidth / 2;
      TurretGroup.centerY = buttonHeight / 2;
      Turret.rect = new Rectangle(0, 0, 1, 1);
      for (var j:int = 0; j < 40; j++) {
	tg.setMousePos(buttonWidth * 0.2, buttonHeight * 0.6);
	tg.update(dummyBuffer);
      }
      for (var i:int = 0; i < 5; i++) {
	for (j = 0; j < 2; j++) {
	  tg.setMousePos(buttonWidth * 0.2, buttonHeight * 0.6);
          tg.update(dummyBuffer);
	}
        var al:Number = i * 0.1 + 0.1;
        if (i == 4)
          al = 1;
	Turret.rect = new Rectangle(0, 0, 1 + i * 0.75, 1 + i * 0.75);
	Turret.color = Math.floor(0xff * al + 0x22 * (1 - al)) * 0x10000 +
          Math.floor(0xff * al + 0x66 * (1 - al)) * 0x100 +
            Math.floor(0xff * al + 0x22 * (1 - al)) * 0x1;
	tg.setMousePos(buttonWidth * 0.2, buttonHeight * 0.6);
	tg.update(buffer);
      }
      for (x = 0; x < dw; x++) {
        for (y = 0; y < dh; y++) {
          if (x == 0 || x == dw - 1 || y ==0 || y == dh - 1) {
	    buffer.fillRect(new Rectangle(x * 6, y * 6, 6, 6), 0);
            switch (lvl) {
            case 0:
              buffer.fillRect(new Rectangle(x * 6 + 2, y * 6 + 2, 2, 2), 0x999933);
              break;
            case 1:
              buffer.fillRect(new Rectangle(x * 6 + 1, y * 6 + 1, 4, 4), 0xaaaa55);
              break;
            case 2:
              buffer.fillRect(new Rectangle(x * 6 + 1, y * 6 + 1, 4, 4), 0xcccc77);
              break;
            }
          }
        }
      }
      return sp;
    }
  }
}
