/*
 * $Id: MouseState.as,v 1.1.1.1 2006/07/17 03:27:32 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.util {
  import flash.events.MouseEvent;

  /**
   * Handling a mouse state.
   */
  public class MouseState {
    public var x:int;
    public var y:int;
    private var pressed:Boolean = false;
    private var clicked:Boolean = false;
    private var delta:int = 0;

    public function updateXY(x:Number, y:Number):void {
      this.x = Math.floor(x);
      this.y = Math.floor(y);
    }

    public function onMouseDown(evt:MouseEvent):void {
      pressed = true;
      clicked = true;
    }

    public function onMouseUp(evt:MouseEvent):void {
      pressed = false;
    }

    public function onMouseWheel(evt:MouseEvent):void {
      delta += evt.delta;
    }

    public function readDelta():int {
      var d:int = delta;
      delta = 0;
      return d;
    }

    public function isClicked():Boolean {
      var c:Boolean = clicked;
      clicked = false;
      return c;
    }

    public function isPressed():Boolean {
      return pressed;
    }
  }
}
