/*
 * $Id: BulletML.as,v 1.1.1.1 2006/07/17 03:27:32 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.util.bulletml {
  /**
   * BulletML handler.
   * Call the 'run' method to process a BulletML script.
   */
  public class BulletML {
    private var root:XML;
    private var bml:XML;
    private var actions:Array;

    // Constructor for an entire BulletML.
    public function init(bml:XML, params:Array = null):void {
      root = this.bml = bml;
      actions = new Array;
      for each (var a:XML in bml.action.(@label.search("top") == 0)) {
        var act:Action = new Action;
        act.init(a, root, params);
        actions.push(act);
      }
    }

    // Constructor for a partial BulletML.
    public function initPartial(bml:XML, root:XML, params:Array, bullet:Bullet):void {
      this.bml = bml;
      this.root = root;
      actions = new Array;
      var act:Action;
      for each (var a:XML in bml.action) {
        act = new Action;
        act.init(a, root, params);
        actions.push(act);
      }
      for each (var ar:XML in bml.actionRef) {
        act = new Action;
        act.init(root.action.(@label == ar.@label)[0], root, act.parseParams(ar, bullet, params));
        actions.push(act);
      }
    }

    public function run(bullet:Bullet, bulletPool:BulletPool):void {
      var a:Action;
      for each (a in actions)
        a.run(bullet, bulletPool);
      for (var i:int = 0; i < actions.length; ) {
        a = Action(actions[i]);
        if (a.isEnd())
          actions.splice(i, 1);
        else
          i++;
      }
    }

    public function isEnd():Boolean {
      return (actions.length <= 0);
    }
  }
}
